// default facets for cylinders & Co. 
$fn=100; //Set to 100 for pretty openscad rendering.


TH=200; //Through all Hole

M2=2;
M2_screw=1.8; //to be threaded
M2_through=2.2; //traversant
M2_head=5; //head of screw or washer outside diameter


//////////
// Holders: Laser + Sample (+hole diaf?)
//////////
D_Laser=12; //* Diameter of laser housing
//h_beam=22+10; //* Beam hight
h_beam=25;
laser_angle=45; //* incidence angle on sample

e_clearance_holder=1.3; //minimal thickness of the holder
h_foot=5; //height of the foot
l_thread_top=3; //distance to be threaded for the lens_holding screw

d_c2c_0=D_Laser+2*e_clearance_holder+M2_head; //distance center-to-center of the mounting
echo("\nHolder_LASER, d_c2c_0=",d_c2c_0);
//d_c2c=d_c2c_0-d_c2c_0%2+2;
d_c2c=50;
echo("d_c2c=",d_c2c);



h=15;
d=D_Laser+2*e_clearance_holder;

l_sample=20;
h_laser=h_beam+l_sample*tan(laser_angle);

module Holder_LASER() rotate([0,180,0]) translate([0,h_laser-h_beam,0]) difference(){
    //laser holder
    hull(){
        //head
        rotate([laser_angle,0,0]) translate([0,0,-h+e_clearance_holder+M2_through/2])
            cylinder(h=h,d=d,center=false);
        //hat
        rotate([laser_angle,0,0]) translate([0,l_thread_top/2+D_Laser/2,-h/2+e_clearance_holder+M2_through/2])
            cube([M2+2*e_clearance_holder,l_thread_top,h],center=true);
        //foot
        dh=(D_Laser/2+l_thread_top)*sin(laser_angle)+(e_clearance_holder+M2_through/2)*cos(laser_angle);
        dy=(D_Laser/2+l_thread_top)*cos(laser_angle)-(e_clearance_holder+M2_through/2)*sin(laser_angle);
        translate([0,-h_laser/2+dy/2,0]){
            translate([0,0,dh/2]) cube([d_c2c+M2_through+2*e_clearance_holder,h_laser+dy,dh],center=true);
            dz=M2_through/2+e_clearance_holder;
            translate([0,0,-dz/2]) cube([d_c2c+M2_through+2*e_clearance_holder,h_laser+dy,dz],center=true);
        }
    }
    //laser clear apperture
    rotate([laser_angle,0,0]) cylinder(h=TH,d=D_Laser-e_clearance_holder,center=true);
    //laser head
    rotate([laser_angle,0,0]) rotate([180,0,0]) cylinder(h=TH,d=D_Laser,center=false);
    //laser holding screw
    rotate([laser_angle,0,0]) translate([0,0,-h/2]) rotate([-90,0,0]) cylinder(h=TH,d=M2_screw,center=false);
    //mounting holes
    for(i=[-1,+1]) translate([i*d_c2c/2,0,0]) rotate([90,0,0])
        cylinder(h=TH,d=M2_through,center=true);
    //trim sides
    for(i=[-1,+1])
        translate([i*(TH/2+d_c2c/2-M2_through/2-e_clearance_holder),TH/2-h_laser+h_foot,0])
        cube([TH,TH,TH],center=true); 
    //main beam clear apperture
    translate([0,-h_laser+h_beam,0])
        cylinder(h=TH,d=30,center=true); 
}

Holder_LASER();